﻿angular.module("GpiApiApp")
    .controller("Dashboard", ['$scope', function ($scope, editorState, userService, contentResource, languageResource, notificationsService, gpiResource) {

        var vm = this;
        vm.UserName = '';
        vm.Packages = [];
        vm.Quotes = [];
        vm.Projects = [];
        vm.AvailableSettings = [{ name: "Select a project setting", id: "" }];
        vm.Settings = "";
        vm.loading = true;
        vm.buttonsBlocked = true;
        vm.loadingProcess = null;
        vm.loadedFirstTime = false;
        vm.GettingQuotesError = false;
        // var user = userService.getCurrentUser().then(function (user) {
        //     vm.UserName = user.name;
        // });

        vm.Loading = function (theScope) {
            vm.buttonsBlocked = true;
            vm.loading = !vm.loadedFirstTime;
            vm.listQuotes();
            if (theScope) theScope.$apply();
        }
        vm.init = function (theScope) {
            vm.buttonBlocked = true;
            vm.listSettings(theScope).then(function () { if ((vm.Settings == undefined || vm.Settings == "") && vm.AvailableSettings.length > 0) vm.Settings = vm.AvailableSettings[0]; })
                .then(function () { vm.buttonBlocked = false; });
            vm.Loading();
        };

        // vm.getQuotes = function () {
        //     return optimizelyRequestHelper.resourcePromise(
        //         $http.get("/EPiServer/TSC.Client.Optimizely/GpiApi/GetQuotes"),
        //         "Failed to get quotes.");
        // };
        vm.getQuotes = () => {
            return fetch(location.pathname.replace("/Dashboard", "/GetQuotes" + "?settingsId=" + ((typeof (vm.Settings) == typeof ({}) ? vm.Settings.id : vm.Settings) || "")), {
                method: 'GET'
            })
                .then(response => { vm.GettingQuotesError = false; return response.json() })
                .catch(err => { console.log(err); vm.GettingQuotesError = true; })
        };
        vm.GetAllSettings = () => {
            return fetch(location.pathname.replace("/Dashboard", "/GetAllSettings"), {
                method: 'GET'
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };

        vm.DeletePackage = (packageId, idSettings) => {
            return fetch(location.pathname.replace("/Dashboard", "/DeletePackage?settingsId=" + ((typeof (vm.Settings) == typeof ({}) ? vm.Settings.id : vm.Settings) || "")), {
                method: 'DELETE',
                body: JSON.stringify(packageId),
                headers: {
                    'Content-Type': 'application/json'
                },
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };

        vm.SendQuote = (idQuote, idSettings) => {
            return fetch(location.pathname.replace("/Dashboard", "/SendQuote?settingsId=" + idSettings), {
                method: 'POST',
                body: JSON.stringify(idQuote),
                headers: {
                    'Content-Type': 'application/json'
                },
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };

        vm.ImportTranslations = (idQuote, idSettings) => {
            return fetch(location.pathname.replace("/Dashboard", "/ImportTranslations?settingsId=" + idSettings), {
                method: 'POST',
                body: JSON.stringify(idQuote),
                headers: {
                    'Content-Type': 'application/json'
                },
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };

        vm.CloseProject = (idQuote, idSettings) => {
            return fetch(location.pathname.replace("/Dashboard", "/CloseProject?settingsId=" + idSettings), {
                method: 'PUT',
                body: JSON.stringify(idQuote),
                headers: {
                    'Content-Type': 'application/json'
                },
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };


        vm.listQuotes = function (event, element) {

            if (!vm.Settings) return null;
            vm.getQuotes().then(function (quotes) {
                vm.GettingQuotesError = quotes == undefined;
                vm.Packages = [];
                vm.Quotes = [];
                vm.Projects = [];

                angular.forEach(quotes, function (quote) {
                    if (quote.status == 'ProjectStarted') {
                        quote.statusDetail = 'Project Started';
                        vm.Projects.push(quote);
                    }
                    else if (quote.status == 'ProjectCompleted') {
                        quote.statusDetail = 'Project Completed';
                        quote.loading = false;
                        vm.Projects.push(quote);
                    }
                    else if (quote.status == 'QuoteInProgress') {
                        quote.statusDetail = 'Quote In Progress';
                        vm.Quotes.push(quote);
                    }
                    else if (quote.status == 'QuoteFinished') {
                        quote.statusDetail = 'Analysis Finished';
                        vm.Quotes.push(quote);
                    } else {
                        quote.statusDetail = quote.status.replace(/([A-Z])/g, ' $1');
                        vm.Packages.push(quote);
                    }
                });
                vm.loading = false;
                vm.loadedFirstTime = true;
            }).catch(err => { console.log(err); vm.GettingQuotesError = true;});
        };
        vm.listSettings = function (event, element) {

            return vm.GetAllSettings().then(function (settings) {
                vm.AvailableSettings = [];

                angular.forEach(settings, function (setting, i) {
                    vm.AvailableSettings.push(setting);
                    if (i == 0) vm.Settings = setting;
                    // Array.from(document.querySelectorAll("option[value='']"))[0].selected = true;
                });
            });
        };

        vm.importTranslations = function (id) {
            vm.loadingProcess = id;
            vm.buttonsBlocked = true;
            var project = vm.Projects.filter(function (proj) {
                return proj.id == id;
            });
            project[0].loading = true;
            vm.ImportTranslations(id, ((typeof (vm.Settings) == typeof ({}) ? vm.Settings.id : vm.Settings) || "")).then(function (res) {
                project[0].loading = false;
                // notificationsService.success("GPI TSC", 'Imported translations for Project #' + id + '. Details: ' + res);
            }).then(() => { vm.buttonBlocked = false; vm.loadingProcess = null; });
        };

        vm.closeProject = function (id) {
            vm.loadingProcess = id;
            vm.buttonsBlocked = true;
            var project = vm.Projects.filter(function (proj) {
                return proj.id == id;
            });
            project[0].loading = true;
            vm.CloseProject(id, ((typeof (vm.Settings) == typeof ({}) ? vm.Settings.id : vm.Settings) || "")).then(function (res) {
                project[0].loading = false;
            }).then(() => { vm.buttonBlocked = false; vm.loadingProcess = null; });
        };

        vm.ChangeSettings = function () {
            vm.Loading();
        }

        vm.deletePackage = function (package) {
            var confirmDelete = confirm("Do you confirm deleting package '" + package.name + "'?")
            if (confirmDelete) {
                vm.DeletePackage(package.id, vm.Settings).then(function () {
                    vm.Loading();
                });
            }
        }
        vm.editPackage = function (package) {
            location.href = location.href.replace("/Dashboard", "/NewQuote?settingsId=" + ((typeof (vm.Settings) == typeof ({}) ? vm.Settings.id : vm.Settings) || "") + "&idQuote=" + package.id);
        }
        vm.sendQuote = function (package) {
            vm.loadingProcess = package.id;
            vm.buttonBlocked = true;
            vm.SendQuote(package.id, ((typeof (vm.Settings) == typeof ({}) ? vm.Settings.id : vm.Settings) || "")).then(function () {
                vm.Loading();
            }).then(() => { vm.buttonBlocked = false; vm.loadingProcess = null; });
        }
        vm.getRelatedContentLink = function (id) {
            return location.href.replace('/Dashboard', '/RelatedContent?settingsId=' + ((typeof (vm.Settings) == typeof ({}) ? vm.Settings.id : vm.Settings) || "") + '&id=' + id);
        };

        vm.init($scope);
        refresh();
        var interval;
        function refresh() {
            clearInterval(interval);
            vm.Loading();
            interval = setInterval(function () {
                refresh()
            }, vm.loadedFirstTime ? 10000 : 3000);
        }
        setInterval(function () {
            $scope.$apply();
        }, 500);

    }]);