﻿var app = angular.module('GpiApiApp', []);
angular.module("GpiApiApp").factory("gpiResource",
    function ($q, $http, optimizelyRequestHelper) {
        return {
            createPackage: function (objectForTranslation) {
                return optimizelyRequestHelper.resourcePromise(
                    $http.post("backoffice/GpiTranslationServicesConnector/GpiApi/CreatePackage", JSON.stringify(objectForTranslation)),
                    "Failed to create package.");
            },
            getQuotes: function () {
                return optimizelyRequestHelper.resourcePromise(
                    $http.get("backoffice/GpiTranslationServicesConnector/GpiApi/GetQuotes"),
                    "Failed to get quotes.");
            },
            importTranslations: function (id) {
                return optimizelyRequestHelper.resourcePromise(
                    $http.post("backoffice/GpiTranslationServicesConnector/GpiApi/ImportTranslations?id=" + id),
                    "Failed to import translations.");
            },
            saveSettings: function (gpiSettings) {
                return optimizelyRequestHelper.resourcePromise(
                    $http.post("backoffice/GpiTranslationServicesConnector/GpiApi/SaveSettings", JSON.stringify(gpiSettings)),
                    "Failed to save settings.");
            },
            getSettings: function () {
                return optimizelyRequestHelper.resourcePromise(
                    $http.get("backoffice/GpiTranslationServicesConnector/GpiApi/GetSettings"),
                    "Failed to get settings.");
            },
            sendDictionaryForTranslation: function (objectForTranslation) {
                return optimizelyRequestHelper.resourcePromise(
                    $http.post("backoffice/GpiTranslationServicesConnector/GpiApi/SendDictionaryForTranslation", JSON.stringify(objectForTranslation)),
                    "Failed to send dictionary for translation.");
            },
            getAlert: function (text) {
                alert(text);
            }
            
        };
    });
