﻿angular.module("GpiApiApp")
    .controller("NewQuote", ['$scope', '$filter', function ($scope, $filter, editorState, userService, contentResource, languageResource, notificationsService, gpiResource) {

        var vm = this;
        vm.gpiResourceParam = gpiResource;
        vm.UserName = '';
        vm.AvailableSettings = [];
        vm.AvailableLanguages = [];
        vm.Settings = {};
        vm.Name = "";
        vm.Notes = "";
        vm.SourceLanguage = "en";
        vm.TargetLanguages = [];
        vm.SettingsId = location.search.substring(location.search.indexOf('settingsId') + 1, location.search.indexOf('&')).split('=')[1];
        vm.QuoteId = location.search.substring(location.search.indexOf('&') + 1).split('=')[1];

        // vm.loadtree = [{ "id": "Pages", "name": "", "selected": false, "contentType": 4, "children": [{ "id": "5", "name": "Id: 5 Start", "selected": false, "contentType": 2, "children": [{ "id": "10", "name": "Id: 10 About us", "selected": false, "contentType": 2, "children": [{ "id": "27", "name": "Id: 27 Management", "selected": true, "contentType": 0, "children": [] }, { "id": "28", "name": "Id: 28 Contact us", "selected": true, "contentType": 0, "children": [] }] }, { "id": "30", "name": "Id: 30 How to buy", "selected": false, "contentType": 2, "children": [{ "id": "31", "name": "Id: 31 Find a reseller", "selected": true, "contentType": 0, "children": [] }] }] }] }, { "id": "Blocks", "name": "", "selected": false, "contentType": 4, "children": [{ "id": "53", "name": "Alloy Track", "selected": false, "contentType": 1, "children": [{ "id": "56", "name": "Id: 56 Events list", "selected": true, "contentType": 5, "children": [] }, { "id": "57", "name": "Id: 57 News list", "selected": true, "contentType": 5, "children": [] }] }] }];

        // vm.AvailablePages = this.loadtree[0].children;
        // vm.AvailableBlocks = this.loadtree[1].children;

        vm.AvailablePages = [];
        vm.AvailableBlocks = [];
        vm.AvailableCatalogues = [];

        vm.SelectedPages = [];
        vm.SelectedBlocks = [];
        vm.SelectedCatalogues = [];
        vm.contentTypes = ["Content",
            "Folder",
            "Mixed",
            "File",
            "Other",
            "Block",
            "MixedBlock"];

        vm.Loading = function (theScope) {
            vm.loading = true;
            if (theScope) theScope.$apply();
            vm.loading = false;
        }
        vm.init = function () {
            vm.loading = true;
            vm.listSettings();
            vm.listLanguages();
            if (vm.settingsId && !vm.Setting && vm.AvailableSettings) { vm.Settings = vm.AvailableSettings.filter(s => s.id == vm.settingsId)[0]; }
            vm.loadTrees();

            //if (this.AvailablePages.length == 0)
            //if (this.AvailableBlocks.length == 0)
            vm.Loading();
            vm.loading = false;
        };

        vm.checkIfItemIsSelected = function (arr, arrSelection) {
            if (arr) {
                arr.map((element, i) => {
                    var theElement = vm.getItemForInsert(arrSelection, element.id);
                    if (theElement) {
                        if (vm.getCheckState(theElement) > 0) vm.setCheckState(element, vm.getCheckState(theElement));
                        element.selected = theElement.selected;
                        arr[i].selected = theElement.selected;
                        if (theElement.children) { vm.getItemsFromParent(element.pane, element.id); };
                    }
                    if (vm.getCheckState(element) > 0) {
                        vm.getItemsFromParent(element.pane, element.id).then(function () {
                            vm.checkIfItemIsSelected(vm.getItemForInsert(vm['Available' + element.pane], element.id).children, arrSelection)
                        });
                    };
                    if (element.children) { vm.checkIfItemIsSelected(element.children, arrSelection) };
                    // var arrFiltered = arrSelection.filter(fa => fa.id == element.id);
                    // if (arrFiltered && arrFiltered.length > 0 && element.id == arrFiltered[0].id) {
                    //     element.selected = arrFiltered[0].selected;
                    //     if (vm.getCheckState(arrFiltered[0])) vm.setCheckState(element,vm.getCheckState(arrFiltered[0]));
                    //     if (element.children && arrFiltered[0].children) vm.checkIfItemIsSelected(element.children, arrFiltered[0].children);
                    // }
                });
            }
        }

        vm.getItemForInsert = function (element, matchingId) {

            if (Array.isArray(element)) {
                var result = null;
                for (i = 0; result == null && i < element.length; i++) {
                    result = vm.getItemForInsert(element[i], matchingId);
                    if (result != null) {
                        if (vm.Quote && vm.Quote.treeNodes) {
                            var theElement = vm.getItemForInsert(vm.Quote.treeNodes[result.pane == "Pages" ? 0 : result.pane == "Blocks" ? 1 : 2], result.id);
                            if (theElement) result.selected = theElement.selected;
                        }
                        return result
                    };
                }
            } else {
                if (element.id == matchingId) {
                    return element;
                } else if (element.children != null) {
                    var i;
                    var result = null;
                    for (i = 0; result == null && i < element.children.length; i++) {
                        result = vm.getItemForInsert(element.children[i], matchingId);
                    }
                    return result;
                }
                return null;
            }
        }

        vm.toggleSelection = function (language) {

            var idx = vm.TargetLanguages.indexOf(language);
            if (idx > -1) {
                vm.TargetLanguages.splice(idx, 1);
            }
            else {
                vm.TargetLanguages.push(language);
            }
        };
        vm.GetSourceLanguageName = function () {
            var idx = (vm.AvailableLanguages.map(function (sl) { return sl.id; })).indexOf(vm.SourceLanguage);
            if (idx > -1) {
                return vm.AvailableLanguages[idx].name;
            }
            return null;
        };
        vm.GetLanguageByName = function (languageName) {
            var idx = (vm.AvailableLanguages.map(function (sl) { return sl.name; })).indexOf(languageName);
            if (idx > -1) {
                return vm.AvailableLanguages[idx];
            }
            return null;
        };
        vm.GetLanguagesNotSelectedInSource = function () {
            return vm.AvailableLanguages.filter((lang) => lang.id != vm.SourceLanguage);
        };
        vm.CreatePackage = (package) => {
            return fetch(location.pathname.replace("/NewQuote", "/CreatePackage?settingsId=" + ((typeof (vm.Settings) == typeof ({}) ? vm.Settings.id : vm.Settings) || "")), {
                method: 'POST',
                body: JSON.stringify(package),
                headers: {
                    'Content-Type': 'application/json'
                },
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };
        vm.SaveQuote = (quote) => {
            return fetch(location.pathname.replace("/NewQuote", "/SaveQuote"), {
                method: 'POST',
                body: JSON.stringify(quote),
                headers: {
                    'Content-Type': 'application/json'
                },
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };

        vm.GetTreeNodeList = itemList => {
            return itemList.filter(item => vm.getCheckState(item) > 0).map(item => (vm.ToTreeNode(item)));
        };
        vm.ToTreeNode = item => ({
            id: item.id,
            name: item.name,
            selected: item.selected,
            contentType: item.contentType,//m.contentTypes[item.contentType],
            children: vm.GetTreeNodeList(item.children)
        });

        vm.createPackage = function () {
            vm.loading = true;
            var package = {
                "Id": 0,
                // "QuoteNo":0,
                "Name": vm.Name,
                "Notes": vm.Notes,
                "SourceLanguage": vm.SourceLanguage,
                "TargetLanguages": vm.TargetLanguages,
                "SelectedPageIds": vm.SelectedPages,
                "SelectedBlockIds": vm.SelectedBlocks,
                "SelectedCatalogIds": vm.SelectedCatalogues,
                "TreeNodes": [
                    {
                        id: "Pages",
                        name: "",
                        selected: false,
                        contentType: 4,//vm.contentTypes[4],
                        children: this.GetTreeNodeList(vm.AvailablePages)
                    }, {
                        id: "Blocks",
                        name: "",
                        selected: false,
                        contentType: 4,//vm.contentTypes[4],
                        children: this.GetTreeNodeList(vm.AvailableBlocks)
                    }, {
                        id: "Catalogues",
                        name: "",
                        selected: false,
                        contentType: 4,//vm.contentTypes[4],
                        children: this.GetTreeNodeList(vm.AvailableCatalogues)
                    }]
            }

            vm.CreatePackage(package).then(function (res) {
                vm.init();
                vm.loading = false;
                if (res && res.id)
                    document.location = location.pathname.replace("/NewQuote", "/Dashboard");
            });
        };
        vm.saveQuote = function () {
            vm.loading = true;
            var package = {
                "Id": vm.QuoteId,
                // "QuoteNo":0,
                "Name": vm.Name,
                "Notes": vm.Notes,
                "SourceLanguage": vm.SourceLanguage,
                "TargetLanguages": vm.TargetLanguages,
                "SelectedPageIds": vm.SelectedPages,
                "SelectedBlockIds": vm.SelectedBlocks,
                "SelectedCatalogIds": vm.SelectedCatalogues,
                "TreeNodes": [
                    {
                        id: "Pages",
                        name: "",
                        selected: false,
                        contentType: 4,//vm.contentTypes[4],
                        children: this.GetTreeNodeList(vm.AvailablePages)
                    }, {
                        id: "Blocks",
                        name: "",
                        selected: false,
                        contentType: 4,//vm.contentTypes[4],
                        children: this.GetTreeNodeList(vm.AvailableBlocks)
                    }, {
                        id: "Catalogues",
                        name: "",
                        selected: false,
                        contentType: 4,//vm.contentTypes[4],
                        children: this.GetTreeNodeList(vm.AvailableCatalogues)
                    }]
            }

            vm.SaveQuote(package).then(function (res) {
                vm.init();
                vm.loading = false;
                if (res && res.id)
                    document.location = location.pathname.replace("/NewQuote", "/Dashboard");
            });
        };

        vm.GetAllSettings = () => {
            return fetch(location.pathname.replace("/NewQuote", "/GetAllSettings"), {
                method: 'GET'
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };
        vm.GetAllLanguages = () => {
            return fetch(location.pathname.replace("/NewQuote", "/GetAllLanguages"), {
                method: 'GET'
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };
        vm.GetItems = (pane, id) => {
            return fetch(location.pathname.replace("/NewQuote", "/GetAvailable" + pane + "?settingsId=" + ((typeof (vm.Settings) == typeof ({}) ? vm.Settings.id : vm.Settings) || "") + "&sourceLanguageStr=" + vm.SourceLanguage + "&parent=" + id), {
                method: 'GET'
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };
        vm.GetQuote = (id) => {
            return fetch(location.pathname.replace("/NewQuote", "/GetQuote?settingsId=" + vm.SettingsId + "&idQuote=" + id), {
                method: 'GET'
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };


        vm.listSettings = function (event, element) {

            vm.GetAllSettings().then(function (settings) {
                vm.AvailableSettings = [];

                angular.forEach(settings, function (setting) {
                    vm.AvailableSettings.push(setting);
                    if (setting.id == vm.settingsId) vm.Settings = setting;
                });
                if (vm.Settings.id == undefined && vm.AvailableSettings.length > 0) vm.Settings = vm.AvailableSettings[0];
            });
        };
        vm.listLanguages = function (event, element) {

            vm.GetAllLanguages().then(function (languages) {
                vm.AvailableLanguages = [];

                angular.forEach(languages, function (language) {
                    vm.AvailableLanguages.push(language);
                });
            });
        };

        vm.getQuote = function () {

            return vm.GetQuote(vm.QuoteId).then(function (quote) {
                vm.Name = quote.name;
                vm.Notes = quote.notes;
                vm.TargetLanguages = quote.targetLanguages.map(tl => { var lang = vm.GetLanguageByName(tl); return lang ? lang.id : tl });
                var sourceLang = vm.GetLanguageByName(quote.sourceLanguage);
                vm.SourceLanguage = (sourceLang) ? sourceLang.id : quote.sourceLanguage;
                vm.Quote = quote;
                vm.AddPaneProperty(vm.AvailablePages, "Pages");
                vm.AddPaneProperty(vm.AvailableBlocks, "Blocks");
                vm.AddPaneProperty(vm.AvailableCatalogues, "Catalogues");
            });
        };
        vm.AddPaneProperty = function (arr, pane) {
            arr.pane = pane;
            arr.map((item) => { item.pane = pane; if (arr.children) vm.AddPaneProperty(arr.children, pane); });
        }

        vm.ChangeSettings = function (settingsId) {
            vm.Loading();
        }
        vm.ChangeSourceLanguage = function () {
            vm.loadTrees();
        };

        vm.getItemsFromParent = function (pane, id) {
            return vm.GetItems(pane, id).then(function (items) {
                if (vm['Available' + pane].length == 0) {
                    var parentItem = vm['Available' + pane];
                } else {
                    var parentItemAddCHild = vm.getItemForInsert(vm['Available' + pane], id);
                }
                if (parentItem != null) {
                    angular.forEach(items, function (item) {
                        item.pane = pane;
                        if (vm.Quote) {
                            var theElement = vm.getItemForInsert(vm.Quote.treeNodes[pane == "Pages" ? 0 : pane == "Blocks" ? 1 : 2], item.id);
                            if (theElement && vm.getCheckState(theElement) > 0) vm.setCheckState(item, vm.getCheckState(theElement));
                        }
                        parentItem.pushIfNotExist(item, function (e) {
                            return e.id === item.id;
                        });
                    });
                }
                if (parentItemAddCHild != null) {
                    angular.forEach(items, function (item) {
                        item.pane = pane;
                        if (vm.Quote) {
                            var theElement = vm.getItemForInsert(vm.Quote.treeNodes[pane == "Pages" ? 0 : pane == "Blocks" ? 1 : 2], item.id);
                            if (theElement && vm.getCheckState(theElement) > 0) vm.setCheckState(item, vm.getCheckState(theElement));
                        }
                        parentItemAddCHild.children.pushIfNotExist(item, function (e) {
                            return e.id === item.id;
                        });
                    });
                }
            });
        }


        vm.toggleAllCheckboxes = function ($event) {
            var i,
                item,
                len,
                ref,
                results,
                selected;
            selected = $event.target.checked;
            ref = vm.AvailablePages;
            results = [];
            for (i = 0, len = ref.length; i < len; i++) {
                item = ref[i];
                item.selected = selected;
                if (item.children != null) {
                    results.push($scope.$broadcast('changeChildren',
                        item));
                } else {
                    results.push(void 0);
                }
            }
            return results;
        };
        vm.initCheckbox = function (item,
            parentItem) {
            return item.selected = parentItem && parentItem.selected || item.selected || false;
        };
        vm.toggleCheckbox = function (item, parentScope) {
            item.selected = !item.selected;
            if (item.selected)
                vm['Selected' + item.pane].pushIfNotExist(item.id, (e) => e == item);
            else
                vm['Selected' + item.pane].splice(vm['Selected' + item.pane].indexOf(item.id), 1);

            if (item.children != null) {
                $scope.$broadcast('changeChildren', item);
            }
            if (parentScope.item != null) {
                return $scope.$emit('changeParent', parentScope);
            }

        };

        vm.getCheckState = function (item) {
            if (item.selected || item.checkState == 2)
                return 2;
            else
                if (
                    (item.children && ($filter('selected')(item.children).length > 0 ||
                        item.children.some(i => vm.getCheckState(i) > 0))) ||
                    (item.children && ($filter('checkState1')(item.children).length > 0 ||
                        item.children.some(i => i.checkState > 0))) ||
                    (item.children && ($filter('checkState2')(item.children).length > 0 ||
                        item.children.some(i => i.checkState > 0))) ||
                    item.checkState == 1
                )
                    return 1;
                else
                    return 0;
        };
        vm.setCheckState = function (item, val) {
            item.checkState = val;
        };
        vm.itemHasChildren = function (item) {
            return (item.children != null && item.children.length > 0)
                || (isNaN(item.contentType) ? item.contentType : vm.contentTypes[item.contentType]).toLocaleLowerCase().indexOf('mixed') != -1
                || (isNaN(item.contentType) ? item.contentType : vm.contentTypes[item.contentType]).toLocaleLowerCase().indexOf('folder') != -1;
        }
        vm.loadTrees = function () {
            vm.AvailablePages = [];
            vm.AvailableBlocks = [];
            vm.getItemsFromParent("Pages", "0").then(function () {
                vm.getItemsFromParent("Blocks", "0").then(function () {
                    vm.getItemsFromParent("Catalogues", "0").then(function () {
                        if (vm.QuoteId) {
                            vm.getQuote(vm.QuoteId).then(function () {
                                if (vm.Quote && vm.Quote.treeNodes) vm.checkIfItemIsSelected(vm.AvailablePages, vm.Quote.treeNodes[0].children);
                                if (vm.Quote && vm.Quote.treeNodes) vm.checkIfItemIsSelected(vm.AvailableBlocks, vm.Quote.treeNodes[1].children);
                                if (vm.Quote && vm.Quote.treeNodes) vm.checkIfItemIsSelected(vm.AvailableCatalogues, vm.Quote.treeNodes[2].children);
                            });
                        }
                    });
                });
            });
        };
        vm.getContentType = (item) => isNaN(item.contentType) ? item.contentType : vm.contentTypes[item.contentType];

        vm.init();
        setInterval(function () {
            vm.Loading($scope);
        }, 5000);

        $scope.$on('changeParent',
            function (event,
                parentScope) {
                var children;
                children = parentScope.item.children;
                // parentScope.item.selected = $scope.$filter('selected')(children).length === children.length;
                parentScope = parentScope.$parent.$parent;
                if (parentScope.item != null) {
                    return $scope.$broadcast('changeParent',
                        parentScope);
                }
            });

        setInterval(function () {
            $scope.$apply();
        }, 500);

    }]);

angular.module("GpiApiApp").filter('selected', [
    '$filter',
    function ($filter) {
        return function (files) {
            return $filter('filter')(files,
                {
                    selected: true
                })
        };
    }
]);
angular.module("GpiApiApp").filter('checkState1', [
    '$filter',
    function ($filter) {
        return function (files) {
            return $filter('filter')(files,
                {
                    checkState: 1
                })
        };
    }
]);
angular.module("GpiApiApp").filter('checkState2', [
    '$filter',
    function ($filter) {
        return function (files) {
            return $filter('filter')(files,
                {
                    checkState: 2
                })
        };
    }
]);

// check if an element exists in array using a comparer function
// comparer : function(currentElement)
Array.prototype.inArray = function (comparer) {
    for (var i = 0; i < this.length; i++) {
        if (comparer(this[i])) return true;
    }
    return false;
};

// adds an element to the array if it does not already exist using a comparer 
// function
Array.prototype.pushIfNotExist = function (element, comparer) {
    if (!this.inArray(comparer)) {
        this.push(element);
    }
};
