﻿angular.module("GpiApiApp")
    .controller("Settings", ['$scope', function ($scope, editorState, userService, contentResource, languageResource, notificationsService, angularHelper, gpiResource) {

        var vm = this;
        vm.Name = '';
        vm.ApiKey = '';
        vm.SecretKey = '';
        vm.PublishSetting = 0;
        vm.NotificationUsers = 'current';

        vm.Settings = {};
        vm.SendNotifications = false;

        vm.AvailableSettings = [{ id: "00000000-0000-0000-0000-000000000000", name: "New setting" }];
        vm.Settings = vm.AvailableSettings[0];
        vm.scope = $scope;

        // var user = userService.getCurrentUser().then(function (user) {
        //     vm.UserName = user.name;
        // });

        vm.Loading = function (theScope) {
            vm.loading = true;
            vm.loading = false;
        }
        vm.GetSettings = () => {
            return fetch(location.pathname.replace("/Settings", "/GetSettings" + "?settingsId=" + ((typeof (vm.Settings) == typeof ({}) && vm.Settings != null ? vm.Settings.id : vm.Settings) || "")), {
                method: 'GET'
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };

        vm.GetAllSettings = () => {
            return fetch(location.pathname.replace("/Settings", "/GetAllSettings"), {
                method: 'GET'
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };

        vm.getSettings = function (event, element) {
            vm.GetSettings().then(function (settings) {
                if (settings) {
                    vm.Name = settings.name;
                    vm.ApiKey = settings.apiKey;
                    vm.SecretKey = settings.secretKey;
                    vm.ApiUrl = settings.apiUrl;
                    vm.PublishSetting = settings.publishSetting || 0;
                    vm.SendNotifications = settings.sendNotifications;
                    vm.NotificationUsers = settings.notificationUsers;
                }
            });
        };

        vm.listSettings = function (event, element) {

            vm.GetAllSettings().then(function (settings) {
                vm.AvailableSettings = [{ id: "00000000-0000-0000-0000-000000000000", name: "New setting" }];

                angular.forEach(settings, function (setting) {
                    vm.AvailableSettings.push(setting);
                });
                if ((vm.Settings.id == undefined || vm.Settings.id == "00000000-0000-0000-0000-000000000000") && vm.AvailableSettings.length > 0) vm.Settings = vm.AvailableSettings[0];
            });
        };

        vm.SaveSettings = (settings) => {
            return fetch(location.pathname.replace("/Settings", "/SaveSettings"), {
                method: 'POST',
                body: JSON.stringify(settings),
                headers: {
                    'Content-Type': 'application/json'
                },
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };
        vm.DeleteSettings = (settingsId) => {
            return fetch(location.pathname.replace("/Settings", "/DeleteSettings"), {
                method: 'DELETE',
                body: JSON.stringify(settingsId),
                headers: {
                    'Content-Type': 'application/json'
                },
            })
                .then(response => response.json())
                .catch(err => console.log(err))
        };


        vm.saveSettings = function () {
            vm.loading = true;
            var gpiSettings = {
                Id: typeof (vm.Settings) == "object" && vm.Settings != null ? vm.Settings.id || "00000000-0000-0000-0000-000000000000" : vm.Settings || "00000000-0000-0000-0000-000000000000",
                Name: vm.Name,
                ApiKey: vm.ApiKey,
                SecretKey: vm.SecretKey,
                ApiUrl: vm.ApiUrl,
                PublishSetting: vm.PublishSetting || 0 * 1,
                NotificationUsers: vm.NotificationUsers,
                SendNotifications: vm.SendNotifications
            };
            vm.SaveSettings(gpiSettings).then(function (res) {
                vm.init();
                vm.loading = false;
            });
        };

        vm.toggleSendNotifications = function () {
            vm.SendNotifications = !vm.SendNotifications;
        };

        vm.changePublish = function (val, params) {
            var binary = vm.PublishSetting.toString(2).padStart(3,'0');
            binaryArray = [];
            if (binary[2] == "1") binaryArray.push(1);
            if (binary[1] == "1") binaryArray.push(10);
            if (binary[0] == "1") binaryArray.push(100);
            if (binaryArray.indexOf(val) >= 0)
                binaryArray.splice(binaryArray.indexOf(val));
            else
                binaryArray.push(val);
            vm.PublishSetting = parseInt(binaryArray.reduce((a, b) => a + b, 0),2);
        };


        vm.deleteSettings = function () {
            vm.loading = true;
            var gpiSettingsId = typeof (vm.Settings) == "object" && vm.Settings != null ? vm.Settings.id || "00000000-0000-0000-0000-000000000000" : vm.Settings || "00000000-0000-0000-0000-000000000000";
            vm.DeleteSettings(gpiSettingsId).then(function (res) {
                vm.init();
                vm.loading = false;
            });
        };

        vm.ChangeSettings = function (settingsId) {
            vm.getSettings();
        }


        vm.init = function () {
            vm.loading = false;
            vm.listSettings();
            vm.Settings = vm.AvailableSettings[0];
            vm.getSettings();
        };

        vm.init();

        setInterval(function() {
            $scope.$apply();
        }, 500);
    }]);